﻿namespace TestProject
{
    /// <summary>
    /// 진행 객체
    /// </summary>
    public class ProgressingObject : BaseObject
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 진행도
        /// </summary>
        private int progress;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 진행도 - Progress

        /// <summary>
        /// 진행도
        /// </summary>
        public int Progress
        {
            get
            {
                return this.progress;
            }
            set
            {
                if(ReferenceEquals(this.progress, value))
                {
                    return;
                }

                this.progress = value;

                OnPropertyChanged("Progress");

                if(OwnerProgressingObject != null)
                {
                    OwnerProgressingObject.UpdateProgress();
                }
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 진행도 계산하기 - UpdateProgress()

        /// <summary>
        /// 진행도 갱신하기
        /// </summary>
        public virtual void UpdateProgress()
        {
        }

        #endregion
    }
}