﻿using System.Collections.ObjectModel;

namespace TestProject
{
    /// <summary>
    /// 프로젝트 객체
    /// </summary>
    public class ProjectObject : ProgressingObject
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 프로젝트 스테이지 컬렉션 - ProjectStageCollection

        /// <summary>
        /// 프로젝트 스테이지 컬렉션
        /// </summary>
        public ObservableCollection<ProjectStage> ProjectStageCollection { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ProjectObject()

        /// <summary>
        /// 생성자
        /// </summary>
        public ProjectObject()
        {
            ProjectStageCollection = new ObservableCollection<ProjectStage>();

            ProjectStageCollection.CollectionChanged += (sender, e) => { UpdateProgress(); };
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 진행도 갱신하기 - UpdateProgress()

        /// <summary>
        /// 진행도 갱신하기
        /// </summary>
        public override void UpdateProgress()
        {
            int completed = 0;
            int summary   = 0;
            
            if(ProjectStageCollection != null)
            {
                foreach(ProjectStage projectStage in ProjectStageCollection)
                {
                    summary++;

                    if(projectStage.Progress >= 100)
                    {
                        completed++;
                    }
                }
            }

            if(summary == 0)
            {
                Progress = 100;
            }
            else
            {
                Progress = completed * 100 / summary;
            }
        }

        #endregion
    }
}