﻿using System.Collections.ObjectModel;

namespace TestProject
{
    /// <summary>
    /// 프로젝트 스테이지
    /// </summary>
    public class ProjectStage : ProgressingObject
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 과제 컬렉션 - TaskCollection

        /// <summary>
        /// 과제 컬렉션
        /// </summary>
        public ObservableCollection<Task> TaskCollection { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ProjectStage()

        /// <summary>
        /// 생성자
        /// </summary>
        public ProjectStage()
        {
            TaskCollection = new ObservableCollection<Task>();

            TaskCollection.CollectionChanged += (sender, e) => { this.UpdateProgress(); };
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 진행도 갱신하기 - UpdateProgress()

        /// <summary>
        /// 진행도 갱신하기
        /// </summary>
        public override void UpdateProgress()
        {
            int completed = 0;
            int summary   = 0;

            if(TaskCollection != null)
            {
                foreach(Task task in TaskCollection)
                {
                    summary++;

                    if(task.State == null || task.State.Value == 2)
                    {
                        completed++;
                    }
                }
            }

            if(summary == 0)
            {
                Progress = 100;
            }
            else
            {
                Progress = completed * 100 / summary;
            }
        }

        #endregion
    }
}