﻿using System;
using System.Collections.Generic;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 상태
    /// </summary>
    public class State : IComparable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 이미지 소스 - ImageSource

        /// <summary>
        /// 이미지 소스
        /// </summary>
        public ImageSource ImageSource { get; set; }

        #endregion
        #region 텍스트 - Text

        /// <summary>
        /// 텍스트
        /// </summary>
        public string Text { get; set; }

        #endregion
        #region 값 - Value

        /// <summary>
        /// 값
        /// </summary>
        public int Value { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            return Text;
        }

        #endregion
        #region 비교하기 - CompareTo(sourceObject)

        /// <summary>
        /// 비교하기
        /// </summary>
        /// <param name="sourceObject">소스 객체</param>
        /// <returns>비교 결과</returns>
        public int CompareTo(object sourceObject)
        {
            return Comparer<int>.Default.Compare(Value, ((State)sourceObject).Value);
        }

        #endregion
    }
}