﻿using System;
using System.Collections.Generic;
using System.Windows.Media.Imaging;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 상태 리스트
    /// </summary>
    public class StateList : List<State>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 상태 리스트
        /// </summary>
        private static List<State> _stateList;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 데이터 소스 - DataSource

        /// <summary>
        /// 데이터 소스
        /// </summary>
        public static List<State> DataSource
        {
            get
            {
                if(_stateList == null)
                {
                    _stateList = new List<State>();

                    _stateList.Add(new State() { Text = "Not started", Value = 0, ImageSource = new BitmapImage(new Uri("Image/state_notstarted.png", UriKind.Relative)) });
                    _stateList.Add(new State() { Text = "In progress", Value = 1, ImageSource = new BitmapImage(new Uri("Image/state_inprogress.png", UriKind.Relative)) });
                    _stateList.Add(new State() { Text = "Completed"  , Value = 2, ImageSource = new BitmapImage(new Uri("Image/state_completed.png" , UriKind.Relative)) });
                }

                return _stateList;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 이미지 소스 - ImageSource

        /// <summary>
        /// 이미지 소스
        /// </summary>
        public ImageSource ImageSource { get; set; }

        #endregion
    }
}