﻿using System;
using System.Collections.ObjectModel;

namespace TestProject
{
    /// <summary>
    /// 뷰 모델
    /// </summary>
    public class ViewModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 프로젝트 객체 컬렉션 - ProjectObjectCollection

        /// <summary>
        /// 프로젝트 객체 컬렉션
        /// </summary>
        public ObservableCollection<ProjectObject> ProjectObjectCollection { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public ViewModel()
        {
            ProjectObjectCollection = InitializeProjectObjectCollection();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Betaron 프로젝트 객체 초기화 하기 - InitializeBetaronProjectObject(projectObject)

        /// <summary>
        /// Betaron 프로젝트 객체 초기화 하기
        /// </summary>
        /// <param name="projectObject">프로젝트 객체</param>
        private void InitializeBetaronProjectObject(ProjectObject projectObject)
        {
            projectObject.Executor = "Mcfadyen Ball";

            ProjectStage projectStage21 = new ProjectStage()
            {
                Name                   = "Information Gathering",
                Executor               = "Kaiden Savastano",
                OwnerProgressingObject = projectObject
            };

            projectStage21.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Market research",
                    Executor               = "Carmine Then",
                    StartDate              = new DateTime(2011, 10, 1),
                    EndDate                = new DateTime(2011, 10, 5 ),
                    State                  = StateList.DataSource[2],
                    OwnerProgressingObject = projectStage21
                }
            );

            projectStage21.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Making specification",
                    Executor               = "Seto Kober",
                    StartDate              = new DateTime(2011, 10, 5),
                    EndDate                = new DateTime(2011, 10, 10),
                    State                  = StateList.DataSource[1],
                    OwnerProgressingObject = projectStage21
                }
            );

            ProjectStage projectStage22 = new ProjectStage()
            {
                Name                   = "Planning",
                Executor               = "Manley Difrancesco",
                OwnerProgressingObject = projectObject
            };

            projectStage22.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Documentation",
                    Executor               = "Martez Gollin",
                    StartDate              = new DateTime(2011, 10, 15),
                    EndDate                = new DateTime(2011, 10, 16),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage22
                }
            );

            ProjectStage projectStage23 = new ProjectStage()
            {
                Name                   = "Design",
                Executor               = "Clint Mary",
                OwnerProgressingObject = projectObject
            };

            projectStage23.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Design of a web pages",
                    Executor               = "Gasper Hartsell",
                    StartDate              = new DateTime(2011, 10, 13),
                    EndDate                = new DateTime(2011, 10, 14),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage23
                }
            );

            projectStage23.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Pages layout",
                    Executor               = "Shirish Huminski",
                    StartDate              = new DateTime(2011, 10, 13),
                    EndDate                = new DateTime(2011, 10, 14),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage23
                }
            );

            ProjectStage projectStage24 = new ProjectStage()
            {
                Name                   = "Development",
                Executor               = "Edwin Thone",
                OwnerProgressingObject = projectObject
            };

            projectStage24.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Design",
                    Executor               = "Zarko Knill",
                    StartDate              = new DateTime(2011, 10, 27),
                    EndDate                = new DateTime(2011, 10, 28),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage24
                }
            );

            projectStage24.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Coding",
                    Executor               = "Harley Kirckof",
                    StartDate              = new DateTime(2011, 10, 29),
                    EndDate                = new DateTime(2011, 10, 30),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage24
                }
            );

            ProjectStage projectStage25 = new ProjectStage()
            {
                Name                   = "Testing and Delivery",
                Executor               = "Boucher Hislop",
                OwnerProgressingObject = projectObject
            };

            projectStage25.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Testing",
                    Executor               = "Sarah Ragas",
                    StartDate              = new DateTime(2011, 10, 13),
                    EndDate                = new DateTime(2011, 10, 14),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage25
                }
            );

            projectStage25.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Content",
                    Executor               = "Rashid Terinoni",
                    StartDate              = new DateTime(2011, 10, 13),
                    EndDate                = new DateTime(2011, 10, 14),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage25
                }
            );

            projectObject.ProjectStageCollection.Add(projectStage21);
            projectObject.ProjectStageCollection.Add(projectStage22);
            projectObject.ProjectStageCollection.Add(projectStage23);
            projectObject.ProjectStageCollection.Add(projectStage24);
            projectObject.ProjectStageCollection.Add(projectStage25);
        }

        #endregion
        #region Stantone 프로젝트 객체 초기화 하기 - InitializeStantoneProjectObject(projectObject)

        /// <summary>
        /// Stantone 프로젝트 객체 초기화 하기
        /// </summary>
        /// <param name="projectObject">프로젝트 객체</param>
        private void InitializeStantoneProjectObject(ProjectObject projectObject) 
        {
            projectObject.Executor = "Ruben Ackerman";

            ProjectStage projectStage11 = new ProjectStage()
            {
                Name                   = "Information Gathering",
                Executor               = "Huyen Trinklein",
                OwnerProgressingObject = projectObject
            };

            projectStage11.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Market research",
                    Executor               = "Tanner Crittendon",
                    StartDate              = new DateTime(2011, 10, 1),
                    EndDate                = new DateTime(2011, 10, 5 ),
                    State                  = StateList.DataSource[2],
                    OwnerProgressingObject = projectStage11
                }
            );

            projectStage11.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Making specification",
                    Executor               = "Carmine Then",
                    StartDate              = new DateTime(2011, 10, 5),
                    EndDate                = new DateTime(2011, 10, 10),
                    State                  = StateList.DataSource[2],
                    OwnerProgressingObject = projectStage11
                }
            );

            ProjectStage projectStage12 = new ProjectStage()
            {
                Name                   = "Planning",
                Executor               = "Alfredo Sookoo",
                OwnerProgressingObject = projectObject
            };

            projectStage12.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Documentation",
                    Executor               = "Gorf Wobbe",
                    StartDate              = new DateTime(2011, 10, 13),
                    EndDate                = new DateTime(2011, 10, 14),
                    State                  = StateList.DataSource[2],
                    OwnerProgressingObject = projectStage12
                }
            );

            ProjectStage projectStage13 = new ProjectStage()
            {
                Name                   = "Design",
                Executor               = "Saphire Plump",
                OwnerProgressingObject = projectObject
            };

            projectStage13.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Design of a web pages",
                    Executor               = "Dominic Minden",
                    StartDate              = new DateTime(2011, 10, 13),
                    EndDate                = new DateTime(2011, 10, 14),
                    State                  = StateList.DataSource[1],
                    OwnerProgressingObject = projectStage13
                }
            );

            projectStage13.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Pages layout",
                    Executor               = "Pinkerton Trezise",
                    StartDate              = new DateTime(2011, 10, 13),
                    EndDate                = new DateTime(2011, 10, 14),
                    State                  = StateList.DataSource[1],
                    OwnerProgressingObject = projectStage13
                }
            );

            ProjectStage projectStage14 = new ProjectStage()
            {
                Name                   = "Development",
                Executor               = "Lauren Partain",
                OwnerProgressingObject = projectObject
            };

            projectStage14.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Design",
                    Executor               = "Delilah Beamer",
                    StartDate              = new DateTime(2011, 10, 23),
                    EndDate                = new DateTime(2011, 10, 24),
                    State                  = StateList.DataSource[1],
                    OwnerProgressingObject = projectStage14
                }
            );

            projectStage14.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Coding",
                    Executor               = "Dunaway Dupriest",
                    StartDate              = new DateTime(2011, 10, 25),
                    EndDate                = new DateTime(2011, 10, 26),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage14
                }
            );

            ProjectStage projectStage15 = new ProjectStage()
            {
                Name = "Testing and Delivery",
                Executor = "Christos Arrant",
                OwnerProgressingObject = projectObject
            };

            projectStage15.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Testing",
                    Executor               = "Grice Ohora",
                    StartDate              = new DateTime(2011, 10, 13),
                    EndDate                = new DateTime(2011, 10, 14),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage15
                }
            );

            projectStage15.TaskCollection.Add
            (
                new Task()
                {
                    Name                   = "Content",
                    Executor               = "Christos Arrant",
                    StartDate              = new DateTime(2011, 10, 13),
                    EndDate                = new DateTime(2011, 10, 14),
                    State                  = StateList.DataSource[0],
                    OwnerProgressingObject = projectStage15
                }
            );

            projectObject.ProjectStageCollection.Add(projectStage11);
            projectObject.ProjectStageCollection.Add(projectStage12);
            projectObject.ProjectStageCollection.Add(projectStage13);
            projectObject.ProjectStageCollection.Add(projectStage14);
            projectObject.ProjectStageCollection.Add(projectStage15);
        }

        #endregion
        #region 프로젝트 객체 컬렉션 초기화 하기 - InitializeProjectObjectCollection()

        /// <summary>
        /// 프로젝트 객체 컬렉션 초기화 하기
        /// </summary>
        /// <returns>프로젝트 객체 컬렉션</returns>
        private ObservableCollection<ProjectObject> InitializeProjectObjectCollection()
        {
            ObservableCollection<ProjectObject> projectObjectCollection = new ObservableCollection<ProjectObject>();

            ProjectObject betaronProjectObject  = new ProjectObject() { Name = "Project : Betaron" };
            ProjectObject stantoneProjectObject = new ProjectObject() { Name = "Project : Stanton" };

            InitializeBetaronProjectObject (betaronProjectObject );
            InitializeStantoneProjectObject(stantoneProjectObject);

            projectObjectCollection.Add(betaronProjectObject );
            projectObjectCollection.Add(stantoneProjectObject);

            return projectObjectCollection;
        }

        #endregion
    }
}